% OPTL_Simulation_New.m

O = zeros(9000,2);    % Omega index
C = zeros(9000,2);    % Number of communities
G = zeros(9000,2);    % CPU Time
d1 = zeros(9000,1);
d2 = zeros(9000,1);
d3 = zeros(9000,1);
d4 = zeros(9000,1);
state = 1;                       % fix state for testing
rand('state', state);
ict = 0;
for r = 2:6                                 % 20 to 6 clusters
    for e1 = 2:4                            % Clique size 4 to 8
        items = 2.*e1;
        p = r.*items;                       % number of variables
        for e2 = 1:3                        % percentage of shared edges
            np = ceil((e2./10).*p);         % # of vars with shared edges
            for e3 = 10:-1:9;               % edge prob
                for nreps = 1:100           % 100 reps per cell
                    omega = zeros(p,r);
                    mem = zeros(p);
                    i1 = 0;
                    for j = 1:r
                        for i = 1:items
                            i1 = i1+1;
                            omega(i1,j) = 1;
                            mem(i1) = j;
                        end
                    end
                    ict = ict + 1
                    prob = e3./10;
                    prob = prob + .05;
                    d1(ict) = r; d2(ict) = items; d3(ict) = np; d4(ict) = prob;
                    g = randperm(p);
                    for k = 1:np
                        iset = g(k);
                        h = randperm(r);
                        if h(1) == mem(iset)
                            omega(iset,h(2)) = 1;
                        else
                            omega(iset,h(1)) = 1;
                        end
                    end
                    colcheck = 0;
                    while colcheck == 0
                        T = eye(p);
                        e6 = rand(p);                        
                        colcheck = 1;
                        for k = 1:r
                            for i = 1:p-1
                                for j = i+1:p
                                    if omega(i,k) == 1 && omega(j,k) == 1
                                        if e6(i,j) <= prob
                                            T(i,j) = 1; T(j,i) = 1;
                                        end
                                    end
                                end
                            end
                        end
                        b = sum(T);
                        bmin = min(b);
                        if bmin < 2
                            colcheck = 0;
                        end
                    end
                    tic;
                    T_nodiag = T - eye(p);
                    [numcliques, X, Y, Z, eta, x, Comm, density, srat, chi, entropy, meanden, minden] = mclscpc3(T_nodiag, 1);
                    G(ict,1) = toc;
                    Ideal = omega;
                    [omegaidx] = omega_index(Comm, Ideal);
                    C(ict,1) = Z;
                    O(ict,1) = omegaidx;
                    tic;
                    [components,cliques,CC] = k_clique(3,T);
                    G(ict,2) = toc;
                    clen = length(components);
                    Com2 = zeros(r.*items,clen);
                    for j = 1:clen
                        x = components{j,:};
                        Com2(x,j) = 1;
                    end
                    [omegaidx2] = omega_index(Com2, Ideal);
                    C(ict,2) = clen;
                    O(ict,2) = omegaidx2;
                end
            end
        end
    end
end
